/*
  Copyright (c) 2013, Matthias Schiffer <mschiffer@universe-factory.net>
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


#ifndef _GMRF_PROTO_BABEL_TLV_TYPES_H_
#define _GMRF_PROTO_BABEL_TLV_TYPES_H_

#include "tlv.h"


typedef struct __attribute__((packed)) gp_babel_tlv_ack_req {
	uint16_t reserved;
	uint16_t nonce;
	uint16_t interval;
} gp_babel_tlv_ack_req_t;

typedef struct __attribute__((packed)) gp_babel_tlv_ack {
	uint16_t nonce;
} gp_babel_tlv_ack_t;

typedef struct __attribute__((packed)) gp_babel_tlv_hello {
	uint16_t reserved;
	uint16_t seqno;
	uint16_t interval;
} gp_babel_tlv_hello_t;

typedef struct __attribute__((packed)) gp_babel_tlv_ihu {
	uint8_t ae;
	uint8_t reserved;
	uint16_t rxcost;
	uint16_t interval;
	uint8_t address[];
} gp_babel_tlv_ihu_t;

typedef struct __attribute__((packed)) gp_babel_tlv_node_id {
	gp_babel_node_id_t id;
} gp_babel_tlv_node_id_t;

typedef struct __attribute__((packed)) gp_babel_tlv_update {
	uint8_t flags;
	uint8_t reserved;
	uint16_t interval;
	uint16_t seqno;
	uint16_t metric;
	uint16_t type;
	uint16_t key;
	uint8_t data[];
} gp_babel_tlv_update_t;

typedef struct __attribute__((packed)) gp_babel_tlv_announce_req {
	uint8_t flags;
	uint8_t reserved;
	gp_babel_node_id_t node;
	uint16_t type;
	uint16_t key;
} gp_babel_tlv_announce_req_t;

typedef struct __attribute__((packed)) gp_babel_tlv_seqno_req {
	uint16_t seqno;
	gp_babel_node_id_t node;
	uint16_t type;
	uint16_t key;
} gp_babel_tlv_seqno_req_t;

#endif /* _GMRF_PROTO_BABEL_TLV_TYPES_H_ */
